<template>
    <label :for="'input-'+name" class="bbox-checkbox-label">
        <div class="display-flex container-checkbox">
            <input type="checkbox" :id="'input-'+name" :checked="value" :name="name" @change="$emit('input', $event.target.checked)">
            <div class="font-size-big checkbox-icon">
                <b-icon v-if="value"><icon-check-box/></b-icon>
                <b-icon v-else><icon-check-box-outline-blank/></b-icon>
            </div>
            <slot name="label"/>
            <span :class="labelClasses" v-if="!$slots.label && !!label">{{ label }}</span>
        </div>
        <span class="input-error font-size-big red-base margin-top-tiny" v-if="!!error"><b-icon><icon-error-outline/></b-icon> {{ error }}</span>
    </label>
</template>

<script>
import BIcon from './Icon.vue';

export default {
    name: 'b-checkbox',
    components: {
        BIcon
    },
    props: {
        /**
        * Name do checkbox
        */
        name: {
            type: String,
            required: true
        },
        /**
        * Valor do checkbox (padrão é false) 
        * @model
        */
        value: {
            type: Boolean,
            default: false
        },
        /**
        * Mensagem de erro
        */
        error: {
            type: String,
            default: ''
        },
        /**
        * Texto do label do checkbox
        */
        label: {
            type: String,
            default: ''
        },
        /**
        * Classes para estilizar o label
        */
        labelClasses: {
          type: String,
          default: "font-size-big ink semi-bold"
        },
    },
}
</script>

<style scoped lang="scss">
    .container-checkbox{
        align-items: flex-start;
    }
    input{
        display: none;
    }
    span.input-error {
        display: block;
        text-align: left;
        line-height: 1;
    }
    .checkbox-icon{
        margin-right: 5px;
        margin-top: -2px;
    }
</style>

<docs>
    BCheckbox
    ```js 
    <bbox-checkbox class="margin-top-big" name="termsAccepted" v-model="termsAccepted" label="Concordo com os termos" />
    <bbox-checkbox class="margin-top-big" name="termsAccepted" v-model="termsAccepted">
        <div slot="label">
          <span class="font-size-big ink semi-bold">Li e aceito os <a href="">termos</a></span>
        </div>
    </bbox-checkbox>
    ```
</docs>